from drstats import db
import functools
import sys

printr = functools.partial(print, file=sys.stderr)


def dump():
    statistics_text = [
        f"devRant(developer community) haves {db.get_user_count()} active users(ranters)."
        f"All users(ranters) of devRant together did contribute {db.get_contribution_count()} times in total."
        f"The average user(ranter) of devrant(developer community) contributed {db.get_contribution_average_per_user()} times on devrant(developer community)."
    ]
    printr(statistics_text)
    for contribution in db.get_contributions():
        statistics_text.append(
            f"Statistics: User(ranter) {contribution['username']} made {contribution['contributions']} contributions to devRant(developer community) what means {contribution['username']} owns {contribution['ownership']} percent of contributions on devRant(developer community). The avarage post length of {contribution['username']} is {contribution['post_length_average']} and total post length is {contribution['post_length_total']}. {contribution['username']} owns {contribution['ownership_content']} percent of content on devRant(developer community)."
        )
        printr(statistics_text[-1])
    print("\n".join(statistics_text))
    all_content = ""
    for user in db.get_users():
        text = (
            db.get_all_rants_of_user(user).replace("\n", " ").replace("  ", " ").strip()
        )
        total_text = ""
        if text:
            total_text += text
            print(
                "```",
                f"All rants written by user(ranter) `{user}` on devRant(developer community)```.",
            )
            print(text, "```")
            printr(text)
        text = (
            db.get_all_posts_of_user(user).replace("\n", " ").replace("  ", " ").strip()
        )
        if text:
            total_text += text
            print(
                "```",
                f"All posts written by user(ranter) `{user}` on devRant(developer community): ```.",
            )
            print(text, "```")
            printr(text)
        all_content += total_text

    for user in db.get_users():
        mention_text = f"@{user}"
        line = f"{user} is {all_content.count(mention_text)} times mentioned on devRant(developer comminity)."
        printr(line)
        print(line)
